﻿using System;

namespace DKE_Kinect.Entwicklung.Core
{
    /// <summary>
    /// Klasse für von uns erweiterte Ausnahmen
    /// </summary>
    class DkeException:Exception
    {
        /// <summary>
        /// Konstruktor mit individueller Nachricht, die ausgegeben wird.
        /// </summary>
        /// <param name="_message">String der als Fehlerbeschreibung ausgegeben wird</param>
        public DkeException(String _message)
            : base(_message)
        { }
        /// <summary>
        /// Konstruktor wenn DkeException eine andere Exception erweitern soll, dabei wird die Nachricht der eigentlichen Exception vorgeschaltet
        /// </summary>
        /// <param name="_message">String der als Fehlerbeschreibung ausgegeben wird</param>
        /// <param name="_innerException">Exception die ummantelt werden soll</param>
        public DkeException(String _message, Exception _innerException):base(_message,_innerException)
        { }
    }
}
