﻿
namespace DKE_Kinect.Entwicklung.Kinect
{
    /// <summary>
    /// Enumeration aller bekannten Gesten
    /// </summary>
   public enum Gestures
    {

        /// <summary>
        /// 0 Right Arm Out
        /// </summary>
        RightArmOut,
        /// <summary>
        /// 1 Right Arm Across
        /// </summary>
        RightArmAcross,
        /// <summary>
        /// 2 Right Arm Forward
        /// </summary>
        RightArmForward,
        /// <summary>
        /// 3 Right Arm Up
        /// </summary>
        RightArmUp,
        /// <summary>
        /// 4 Right Hand Up
        /// </summary>
        RightHandUp,
        /// <summary>
        /// 5 Left Arm Out
        /// </summary>
        LeftArmOut,
        /// <summary>
        /// 6 Left Arm Across
        /// </summary>
        LeftArmAcross,
        /// <summary>
        /// 7 Left Arm Forward
        /// </summary>
        LeftArmForward,
        /// <summary>
        /// 8 Left Arm Up
        /// </summary>
        LeftArmUp,
        /// <summary>
        /// 9 Left Hand Up
        /// </summary>
        LeftHandUp,
        /// <summary>
        /// 10 Swipe Left
        /// </summary>
        SwipeLeft,
        /// <summary>
        /// 11 Swipe Right
        /// </summary>
        SwipeRight,
        /// <summary>
        /// 12 Swipe Up
        /// </summary>
        SwipeUp,
        /// <summary>
        /// 13 Swipe Down
        /// </summary>
        SwipeDown,
        /// <summary>
        /// 14 Swipe Upper Left
        /// </summary>
        SwipeUpperLeft,
        /// <summary>
        /// 15 Swipe Upper Right
        /// </summary>
        SwipeUpperRight,
        /// <summary>
        /// 16 Swipe Lower Left
        /// </summary>
        SwipeLowerLeft,
        /// <summary>
        /// 17 Swipe Lower Right
        /// </summary>
        SwipeLowerRight,
        /// <summary>
        /// (18) Null Gesture = None
        /// </summary>
        None
    }

}
